// SpaFEDTe, a Template based C++ library for creating 
// Discontinuous Finite Element Spaces,
// Copyright (C) 2012 Lorenzo Alessio Botti

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */ 
/* License as published by the Free Software Foundation either */ 
/* version 3.0 of the License, or (at your option) any later version. */

/* This software is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this software; if not, a copy of the full */
/* GNU Lesser General Public License can be found at */
/* http://www.gnu.org/licenses/ */

/* The element names convention is taken from the libMesh library */

#ifndef __enum_elem_type_h__
#define __enum_elem_type_h__

enum ElemType {EDGE2=0,    // 0
               EDGE3,      // 1
               
               TRI3,       // 2
               TRI6,       // 3
               
               QUAD4,      // 4
               QUAD8,      // 5
               QUAD9,      // 6
               
               TET4,       // 7
               TET10,      // 8
               
               HEX8,       // 9 
               HEX20,      // 10
               HEX27,      // 11
               
               PRISM6,     // 12
               PRISM15,    // 13
               
               PYRAMID5,   // 14
               PYRAMID13,  // 15
               
               AGGLOELEM,  // 16 
               NODEELEM,   // 17 
               
               INVALID_ELEM};

#endif 




