// SpaFEDTe, a Template based C++ library for creating 
// Discontinuous Finite Element Spaces,
// Copyright (C) 2012 Lorenzo Alessio Botti

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */ 
/* License as published by the Free Software Foundation either */ 
/* version 3.0 of the License, or (at your option) any later version. */

/* This software is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this software; if not, a copy of the full */
/* GNU Lesser General Public License can be found at */
/* http://www.gnu.org/licenses/ */

#ifndef __felib_base_h__
#define __felib_base_h__

namespace FELib
{

  unsigned int n_processors();

  unsigned int processor_id();

  namespace FELibPrivateData 
  {
    extern int _n_processors;
  
    extern int _processor_id;
  }
}

inline
unsigned int FELib::n_processors()
{
   return static_cast<unsigned int>(FELib::FELibPrivateData::_n_processors);
}



inline
unsigned int FELib::processor_id()
{
   return static_cast<unsigned int>(FELib::FELibPrivateData::_processor_id);
}
#endif
