// SpaFEDTe, a Template based C++ library for creating 
// Discontinuous Finite Element Spaces,
// Copyright (C) 2012 Lorenzo Alessio Botti

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */ 
/* License as published by the Free Software Foundation either */ 
/* version 2.1 of the License, or (at your option) any later version. */

/* This software is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this software; if not, a copy of the full */
/* GNU Lesser General Public License can be found at */
/* http://www.gnu.org/copyleft/lesser.html. */

#ifndef __ItemMappingFunction_h__
#define __ItemMappingFunction_h__

#include "Quadrature.hpp"

template<class MappingBasisFunctionT>
class ItemMappingFunction : public MappingBasisFunctionT
{
public:
  typedef MappingBasisFunctionT MappingBasisFunctionType;
  typedef typename MappingBasisFunctionType::PointVector PointVector;
  typedef typename MappingBasisFunctionType::JacVector JacVector;
  typedef typename MappingBasisFunctionType::CoordVector CoordVector;
  typedef typename MappingBasisFunctionType::DistanceVector DistanceVector;
  typedef typename MappingBasisFunctionType::RotationMatrix RotationMatrix;
  typedef typename MappingBasisFunctionType::NormalVector NormalVector;

  ItemMappingFunction() : MappingBasisFunctionType()
    {
      ;
    } 
  
  ~ItemMappingFunction() { }
  
  MappingBasisFunctionType& getMappingFunction()
  {
    return *this;
  }
  
  const MappingBasisFunctionType& getMappingFunction() const
  {
    return *this;
  }
};

#endif
